/*
 * Copyright 2010 JBoss Inc
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.drools.core.spi;

import org.drools.core.WorkingMemory;
import org.drools.core.base.JavaFactRegistryEntry;

public interface JavaFact {
    public JavaFactRegistryEntry[] listWorkingMemories();

    public boolean register(final WorkingMemory workingMemory);

    public void unregisterAll();

    public boolean unregister(final WorkingMemory workingMemory);

    public boolean isRegistered(final WorkingMemory workingMemory);

    public int[] getChanges();
}
